/*
    u200mon -- the WiMax monitor and logger
    Copyright (C) 2008 Anthony A Z <dci@cpp.in>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "nmea.h"


volatile HANDLE hNmeaDevice = INVALID_HANDLE_VALUE;
char szNmeaBuffer [ 4096 ];

double _nmea_mins_to_degs ( char * string, int entier, int negative )
{
	double ret = 0;
	double fra = 0;
	char * dec = strchr ( string, '.' );
	char * tmp;
	char   buf [ 32 ];
	memcpy ( buf, string, entier );
	buf [ entier ] = 0;
	ret = strtod ( buf, &tmp );
	fra = strtod ( string + entier, &tmp ) / 6;
	if ( dec - entier - string )
	{
		int i;
		for ( i = 0; i < ( dec - entier - string - 1 ); ++i ) fra /= 10;
	}
	else fra *= 10;
	ret += fra;
	if ( negative ) ret *= ( -1 );
	return ret;
}

DWORD WINAPI _nmea_read_thr ( LPVOID lpparam )
{
	while ( INVALID_HANDLE_VALUE != hNmeaDevice )
	{
		DWORD b;
		DWORD u = ( DWORD ) strlen ( szNmeaBuffer );
		if ( u >= ( sizeof ( szNmeaBuffer ) - 1 ) ) u = 0;
		if ( ReadFile ( hNmeaDevice, szNmeaBuffer + u, sizeof ( szNmeaBuffer ) - 1 - u, &b, NULL ) && b )
		{
			char * cutter;
			/* */
			szNmeaBuffer [ u + b ] = 0;
			while ( cutter = strchr ( szNmeaBuffer, '\n' ) )
			{
				char * cmd;
				/* cut line */
				* cutter = 0;
				++cutter;
				/* */
				cmd = strtok ( szNmeaBuffer, "," );
				if ( cmd && !_stricmp ( cmd, "$GPRMC" ) )
				{
					/* time */
					if ( strtok ( NULL, "," ) )
					{
						/* state */
						char * state = strtok ( NULL, "," );
						if ( state && !_stricmp ( state, "a" ) )
						{
							char * lat_value      = strtok ( NULL, "," );
							char * lat_hemisphere = strtok ( NULL, "," );
							if ( lat_value && lat_hemisphere )
							{
								double latitude = _nmea_mins_to_degs ( lat_value, 2, _stricmp ( lat_hemisphere, "n" ) ? 1 : 0 );
								char * long_value      = strtok ( NULL, "," );
								char * long_hemisphere = strtok ( NULL, "," );
								if ( long_value && long_hemisphere )
								{
									double longitude = _nmea_mins_to_degs ( long_value, 3, _stricmp ( long_hemisphere, "e" ) ? 1 : 0 );
									if ( lpparam ) ( ( void ( * ) ( double, double ) ) lpparam ) ( latitude, longitude );
								}
							}
						}
					}
				}
				/* next line */
				while ( ( '\n' == * cutter ) || ( '\r' == * cutter ) ) ++cutter;
				memmove ( szNmeaBuffer, cutter, strlen ( cutter ) + 1 );
			}
		}
		else Sleep ( 50 );
	}
	return 0;
}

long nmea_start ( wchar_t * com, void ( * callback ) ( double, double ) )
{
	hNmeaDevice = CreateFile ( com, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if ( INVALID_HANDLE_VALUE == hNmeaDevice ) return -1;
	CloseHandle ( CreateThread ( NULL, 0, _nmea_read_thr, callback, 0, NULL ) );
	return 0;
}

void nmea_stop  ( )
{
	if ( INVALID_HANDLE_VALUE == hNmeaDevice )
	{
		HANDLE hTmp = hNmeaDevice;
		hNmeaDevice = INVALID_HANDLE_VALUE;
		CloseHandle ( hTmp );
		Sleep ( 200 );
	}
}
