/*
    u200mon -- the WiMax monitor and logger
    Copyright (C) 2008 Anthony A Z <dci@cpp.in>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdio.h>
#include <conio.h>
#include <winsock2.h>
#include <windows.h>
#include <iphlpapi.h>
#include <icmpapi.h>

#include "ping.h"

wchar_t * szHost = NULL;
volatile HMODULE hIcmpLibrary = NULL;
volatile HANDLE hIcmp = INVALID_HANDLE_VALUE;

DWORD WINAPI _ping_thr ( LPVOID lpparam )
{
	FARPROC pIcmpSendEcho = GetProcAddress ( hIcmpLibrary, "IcmpSendEcho" );
	char * host = malloc ( wcslen ( szHost ) + 1 );
	wcstombs ( host, szHost, wcslen ( szHost ) + 1 );
	/* */
	while ( INVALID_HANDLE_VALUE != hIcmp )
	{
		IPAddr ip = inet_addr ( host );
		if ( !ip || ( INADDR_NONE == ip ) )
		{
			HOSTENT * lpHost = gethostbyname ( host );
			if ( lpHost ) ip = * ( ( u_long FAR * ) ( lpHost->h_addr ) );
		}
		/* */
		if ( ( INVALID_HANDLE_VALUE != hIcmp ) && ( ip ) && ( INADDR_NONE != ip ) )
		{
			unsigned char rep [ sizeof ( ICMP_ECHO_REPLY ) + 16 ];
			if ( ( ( DWORD ( WINAPI * ) ( HANDLE, IPAddr, LPVOID, WORD, PIP_OPTION_INFORMATION, LPVOID, DWORD, DWORD ) ) pIcmpSendEcho ) ( hIcmp, ip, "0123456789abcdef", 16, NULL, rep, sizeof ( rep ), 3000 ) )
			{
				if ( IP_SUCCESS == ( ( ICMP_ECHO_REPLY * ) &rep )->Status )
				{
					int rtt = ( ( ICMP_ECHO_REPLY * ) &rep )->RoundTripTime;
					if ( lpparam ) ( ( void ( * ) ( int ) ) lpparam ) ( rtt );
					Sleep ( ( rtt < 1000 ) ? 1000 : 500 );
					continue;
				}
			}
		}
		if ( lpparam ) ( ( void ( * ) ( int ) ) lpparam ) ( -1 );
		/* */
		Sleep ( 500 );
	}
	/* */
	free ( host );
	return 0;
}

long ping_start ( wchar_t * host, void ( * callback ) ( int rtt ) )
{
	WSADATA wsa;
	WSAStartup ( MAKEWORD(2,0), &wsa );
	/* */
	if ( hIcmpLibrary = LoadLibrary ( ( 5 == ( GetVersion ( ) & 0xFFFF ) ) ? L"icmp.dll" : L"iphlpapi.dll" ) )
	{
		hIcmp = ( ( HANDLE ( WINAPI *) ( ) ) GetProcAddress ( hIcmpLibrary, "IcmpCreateFile" ) ) ( );
		if ( INVALID_HANDLE_VALUE != hIcmp )
		{
			szHost = _wcsdup ( host );
			CloseHandle ( CreateThread ( NULL, 0, _ping_thr, callback, 0, NULL ) );
			return 0;
		}
		else
		{
			FreeLibrary ( hIcmpLibrary );
			hIcmpLibrary = NULL;
			return -2;
		}
	}
	return -1;
}

void ping_stop  ( )
{
	if ( hIcmpLibrary )
	{
		if ( INVALID_HANDLE_VALUE != hIcmp )
		{
			HANDLE icmp = hIcmp;
			hIcmp = INVALID_HANDLE_VALUE;
			CloseHandle ( icmp );
			Sleep ( 1000 );
		}
		if ( szHost )
		{
			free ( szHost );
			szHost = NULL;
		}
		FreeLibrary ( hIcmpLibrary );
		hIcmpLibrary = NULL;
	}
	WSACleanup ( );
}
