/*
    u200mon -- the WiMax monitor and logger
    Copyright (C) 2008 Anthony A Z <dci@cpp.in>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <stdio.h>
#include <conio.h>
#include <windows.h>

#include "u200.h"


volatile HANDLE hDevice = INVALID_HANDLE_VALUE;

unsigned short _u200_cmd_num = 0;
unsigned long  _u200_rcv_len = 0;

unsigned char  _u200_cmd_buf [ 0x5EA ];
unsigned char  _u200_rcv_buf [ 0x5EA ];


VOID CALLBACK _u200_read_cmp ( DWORD dwErrorCode, DWORD dwNumberOfBytesTransfered, LPOVERLAPPED lpOverlapped )
{
	_u200_rcv_len = dwNumberOfBytesTransfered;
}

DWORD WINAPI _u200_read_thr ( LPVOID lpparam )
{
	while ( INVALID_HANDLE_VALUE != hDevice )
	{
		OVERLAPPED ol;
		/* submit read request to the driver */
		do memset ( &ol, 0, sizeof ( ol ) );
		while ( ( INVALID_HANDLE_VALUE != hDevice ) && ( FALSE == ReadFileEx ( hDevice, _u200_rcv_buf, sizeof ( _u200_rcv_buf ), &ol, _u200_read_cmp ) ) );
		/* wait for the io completion */
		do if ( INVALID_HANDLE_VALUE == hDevice ) return 0;
		while ( WAIT_TIMEOUT == WaitForSingleObjectEx ( GetCurrentThread ( ), 800, TRUE ) );
		/* got the nasty error? */
		if ( ( 4 == _u200_rcv_len ) && ( 0x1F == _u200_rcv_buf [ 0 ] ) && ( 0x2F == _u200_rcv_buf [ 1 ] ) && ( 0x3F == _u200_rcv_buf [ 2 ] )&& ( 0x4F == _u200_rcv_buf [ 3 ] ) )
		{
			printf ( "Device error. Stopping listener thread.\n" );
			return 0;
		}
		/* got anything? */
		if ( _u200_rcv_len )
		{
			if ( ( 0x15 == _u200_rcv_buf [ 0x0C ] ) && ( 0x02 == _u200_rcv_buf [ 0x0D ] ) )
			{
//				printf ( "DM: code=%02X len=%04X\n", _u200_rcv_buf [ 0x0F ], _u200_rcv_len );
				if ( /* DM_CMD_START_CNF */ 3 == _u200_rcv_buf [ 0x0F ] )
				{
//					FILE * f = fopen ( "X:\\start.bin", "wb" );
//					fwrite ( _u200_rcv_buf + 0x14, 1, _u200_rcv_len - 0x14, f );
//					fclose ( f );
				}
				else if ( /* DM_CMD_STOP_CNF */ 5 == _u200_rcv_buf [ 0x0F ] )
				{
//					FILE * f = fopen ( "X:\\stop.bin", "wb" );
//					fwrite ( _u200_rcv_buf + 0x14, 1, _u200_rcv_len - 0x14, f );
//					fclose ( f );
				}
				else if ( /* DM_CMD_MAC_MNG_MSG */ 0x0C == _u200_rcv_buf [ 0x0F ] )
				{
					/* data (starting from 0x14) is 0x375 bytes len */
					/* almost all params has 0x1000 predefined value for "unsupported in this state"? and 0xE000 for "something bad just happened"? */
					/* 0x150 - 0x151 is Number of sub-channels as BE WORD */
					/* 0x152 - 0x152 is Preamble Index as byte */
					/* 0x234 - 0x237 is UL Data Rate as BE DWORD ? */
					/* 0x238 - 0x23B is DL Data Rate as BE DWORD */
					/* 0x260 - 0x263 is State as BE DWORD (INIT, SYNC, NEGO, NORMAL, SLEEP, IDLE, HHO, FBSS, RESET, RESERVED, UNDEFINED, BE, NRTPS, RTPS, ERTPS, UGS, INITIAL_RNG, BASIC, PRIMARY, SECONDARY, MULTICAST, NORMAL_MULTICAST, SLEEP_MULTICAST, IDLE_MULTICAST, FRAG_BROADCAST, BROADCAST, MANAGEMENT, TRANSPORT) */
					/* 0x264 - 0x267 is CINR*8 as BE DWORD */
					/* 0x26C - 0x26F is Frequency as BE DWORD */
					/* 0x350 - 0x351 is RSSI as BE WORD */
					/* 0x352 - 0x353 is TX Power as BE Word */
					/* 0x356 - 0x357 are frame ratios as bytes */
					/* 0x358 - 0x35E is BSID as byte array */
//					FILE * f = fopen ( "X:\\mac.bin", "wb" );
//					fwrite ( _u200_rcv_buf + 0x14, 1, _u200_rcv_len - 0x14, f );
//					fclose ( f );
					if ( lpparam )
					{
						unsigned int state = ( _u200_rcv_buf [ 0x14 + 0x260 ] << 24 ) | ( _u200_rcv_buf [ 0x14 + 0x261 ] << 16 ) | ( _u200_rcv_buf [ 0x14 + 0x262 ] << 8 ) | _u200_rcv_buf [ 0x14 + 0x263 ];
						unsigned int cinr  = ( _u200_rcv_buf [ 0x14 + 0x264 ] << 24 ) | ( _u200_rcv_buf [ 0x14 + 0x265 ] << 16 ) | ( _u200_rcv_buf [ 0x14 + 0x266 ] << 8 ) | _u200_rcv_buf [ 0x14 + 0x267 ];
						unsigned short rssi  = ( _u200_rcv_buf [ 0x14 + 0x350 ] << 8 ) | _u200_rcv_buf [ 0x14 + 0x351 ];
						unsigned short txpw  = ( _u200_rcv_buf [ 0x14 + 0x352 ] << 8 ) | _u200_rcv_buf [ 0x14 + 0x353 ];
						( ( void ( * ) ( unsigned int, float, short, unsigned short, unsigned char * ) ) lpparam ) ( state, ( ( 0xE000 == rssi ) || ( 4096 == cinr ) ) ? 0 : ( ( ( float ) cinr ) / 8 ), ( short ) ( ( ( 0xE000 == rssi ) || ( 4096 == rssi ) ) ? 0 : rssi ), ( ( 0xE000 == txpw ) || ( 4096 == txpw ) ) ? 0 : txpw, _u200_rcv_buf + 0x14 + 0x358 );
					}
				}
				else if ( /* DM_CMD_??? */ 0x0D == _u200_rcv_buf [ 0x0F ] )
				{
//					FILE * f = fopen ( "X:\\data2.bin", "wb" );
//					fwrite ( _u200_rcv_buf + 0x14, 1, _u200_rcv_len - 0x14, f );
//					fclose ( f );
				}
			}
		}
	}
	return 0;
}

BOOL _u200_cmd ( unsigned short cmd_len, unsigned char funny_0x0F_param, void * cmd )
{
	DWORD dummy;
	memset ( _u200_cmd_buf, 0, sizeof ( _u200_cmd_buf ) );
	_u200_cmd_buf [ 0x0C ] = 0x15;
	_u200_cmd_buf [ 0x0D ] = 0x02;
	_u200_cmd_buf [ 0x0E ] = 0x7F;
	_u200_cmd_buf [ 0x0F ] = funny_0x0F_param;
	_u200_cmd_buf [ 0x10 ] = ( unsigned char ) ( _u200_cmd_num & 0xFF );
	_u200_cmd_buf [ 0x11 ] = ( unsigned char ) ( ( _u200_cmd_num >> 8 ) & 0xFF );
	_u200_cmd_buf [ 0x12 ] = ( unsigned char ) ( cmd_len & 0xFF );
	_u200_cmd_buf [ 0x13 ] = ( unsigned char ) ( ( cmd_len >> 8 ) & 0xFF );
	memcpy ( _u200_cmd_buf + 0x14, cmd, cmd_len );
	_u200_cmd_buf [ 0x14 + cmd_len ] = 0x7E;
	++_u200_cmd_num;
	return DeviceIoControl ( hDevice, 0x00222080, _u200_cmd_buf, 0x14 + cmd_len, NULL, 0, &dummy, NULL ); 
}

long u200_start ( void ( * callback ) ( unsigned int state, float cinr, short rssi, unsigned short tx_power, unsigned char * bsid ) )
{
	if ( INVALID_HANDLE_VALUE != hDevice ) return -1;
	hDevice = CreateFile ( L"\\\\.\\SamsungWiBro", GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED, NULL );
	if ( INVALID_HANDLE_VALUE != hDevice )
	{
		HANDLE hTemp = CreateThread ( NULL, 0, _u200_read_thr, callback, 0, NULL );
		if ( hTemp )
		{
			unsigned int cmd_start = 0x04000000;
			CloseHandle ( hTemp );
			Sleep ( 1000 );
			if ( _u200_cmd ( 4, 2, &cmd_start ) ) return 0;
			hTemp = hDevice;
			hDevice = INVALID_HANDLE_VALUE;
			CloseHandle ( hTemp );
			return -4;
		}
		else return -3;
	}
	else return -2;
}

void u200_stop ( )
{
	if ( INVALID_HANDLE_VALUE != hDevice )
	{
		HANDLE hTemp = hDevice;
		/* */
		char * cmd_stop = "STOP REQ";
		_u200_cmd ( 8, 4, cmd_stop );
		/* */
		Sleep ( 1500 );
		hDevice = INVALID_HANDLE_VALUE;
		CloseHandle ( hTemp );
	}
}
